#ifdef OPENGL_ES
#extension GL_OES_standard_derivatives : enable
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#else
precision mediump float;
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform float u_time;
uniform vec3 u_resolution;	// ӁIdlIvec2Ȃ̂vec3őp
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;

const float FOV = 60.0 * 0.5 * 3.14159265 / 180.0;
const vec3 LIGHT = vec3(-0.577, 0.577, 0.577);
vec3  cam = vec3(0.0, 0.0, 2.0);

// rotate
vec3 rotate(vec3 p, float ang, vec3 axis)
{
	vec3 a = normalize(axis);
	float s = sin(ang);
	float c = cos(ang);
	float r = 1.0 - c;
	mat3 m = mat3(
		a.x * a.x * r + c,
		a.y * a.x * r + a.z * s,
		a.z * a.x * r - a.y * s,
		a.x * a.y * r - a.z * s,
		a.y * a.y * r + c,
		a.z * a.y * r + a.x * s,
		a.x * a.z * r + a.y * s,
		a.y * a.z * r - a.x * s,
		a.z * a.z * r + c
	);
	return m * p;
}

vec3 trans(vec3 p)
{
	return mod(p, 4.0) - 2.0;
}

float dist(vec3 p)
{
	vec3 q = rotate(p, sin(u_time * 0.5), vec3(0.0, 0.0, 1.0));
	q = abs(trans(q));
	return length(max(q - vec3(0.5, 0.5, 0.5), 0.0)) - abs(sin(u_time * 0.5));
}

vec3 getNormal(vec3 p)
{
	float d = 0.0001;
	return normalize(vec3(
		dist(p + vec3(  d, 0.0, 0.0)) - dist(p + vec3( -d, 0.0, 0.0)),
		dist(p + vec3(0.0,   d, 0.0)) - dist(p + vec3(0.0,  -d, 0.0)),
		dist(p + vec3(0.0, 0.0,   d)) - dist(p + vec3(0.0, 0.0,  -d))
		));
}

void main()
{
	// ʒ̍Wɕϊ x:-1.777778~1.777778 y:-1.0~1.0
	vec2 p = (gl_FragCoord.xy * 2.0 - u_resolution.xy) / u_resolution.y;

	// 쐬
	vec3 ray = normalize(vec3(sin(FOV) * p.x, sin(FOV) * p.y, -cos(FOV)));

	// JOi
	cam.z -= u_time * 8.0;

	// }[`O[v
	float d = 0.0;
	float l = 0.0;
	vec3  rp = cam;
	for (int i = 0; i < 64; i++) {
		d = dist(rp);
		l += d;
		rp = cam + ray * l;
	}

	// ǂ
	float h = abs(step(0.001, abs(d)) - 1.0);
	vec3 n = getNormal(rp);
	float f = clamp(dot(LIGHT, n), 0.1, 1.0);

	// F̍쐬
	float r = sin(u_time);
	float g = cos(u_time);
	float b = atan(r, g);

	// ͂Â
	vec2 m = v_texCoord * 2.0 - 1.0;
	vec2 o = abs(m.yx) / vec2(6.0, 4.0);
	m += m * o * o;
	m = abs(m);
	m.x = pow(m.x, 15.0);
	m.y = pow(m.y, 15.0);
	r = mix(abs(r), 0.0, m.x + m.y);
	g = mix(abs(g), 0.0, m.x + m.y);
	b = mix(abs(b), 0.0, m.x + m.y);

	vec3 c = vec3(r, g, b) * f * h;

	gl_FragColor = vec4(c, 1.0);
}
