#ifdef OPENGL_ES
#extension GL_OES_standard_derivatives : enable
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#else
precision mediump float;
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform float u_time;
uniform vec3 u_resolution;	// ӁIdlIvec2Ȃ̂vec3őp
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;

const vec3 lightDir = vec3(-0.577, 0.577, -0.577);
//const vec3 lightDir = vec3(0.7, 1.0, 0.7);

// J̍\
struct Camera
{
	vec3 pos;	// J̈ʒu
	vec3 up;	// J̏xNg
	vec3 dir;	// J̑OxNg
	vec3 side;	// J̉xNg (xNgƑOxNg̊Oρj
};

// ̍\
struct Ray
{
    vec3 pos;		// ݂̌̍W
    vec3 dir;		// ̐is
};

float dist(vec3 p)
{
	return (abs(sin(p.x)) + abs(cos(p.y)) + abs(sin(p.z)) - 1.0) * 0.57735027;
}

vec3 getNormal(vec3 p)
{
	float d = 0.0001;
	return normalize(vec3(
		dist(p + vec3(  d, 0.0, 0.0)) - dist(p + vec3( -d, 0.0, 0.0)),
		dist(p + vec3(0.0,   d, 0.0)) - dist(p + vec3(0.0,  -d, 0.0)),
		dist(p + vec3(0.0, 0.0,   d)) - dist(p + vec3(0.0, 0.0,  -d))
	));
}

mat3 rotX(float angle)
{
	float c = cos(angle);
	float s = sin(angle);
	return mat3(1.0, 0.0, 0.0, 0.0, c, -s, 0.0, s, c);
}

mat3 rotY(float angle)
{
	float c = cos(angle);
	float s = sin(angle);
	return mat3(c, 0.0, s, 0.0, 1.0, 0.0, -s, 0.0, c);
}

void main()
{
	// SWɕϊ
	vec2 p = (gl_FragCoord.xy * 2.0 - u_resolution.xy) / u_resolution.y;
	// 
	p.x = abs(p.x);

	// J̐ݒ
	Camera cam;
	cam.pos = vec3(-1.0, 0.0, -1.0);
	cam.up = vec3(0.0, 1.0, 0.0);
	cam.dir = vec3(0.0, 0.0, 1.0);
	cam.side = cross(cam.up, cam.dir);

	// ̐ݒ
	Ray ray;
	ray.pos = cam.pos;	// ̏ʒu
	ray.dir = normalize(p.x * cam.side + p.y * cam.up + cam.dir); // ̐is̓J̎p狁߂邱Ƃł

	// ]}gNX
	mat3 rot = rotX(-u_time);// * rotY(u_time);

	// C}[`O[v
	float d = 0.0;
	float l = 0.0;
	for (int i = 0; i < 64; i++) {
		d = dist(rot * ray.pos);
		l += d;
		ray.pos = cam.pos + ray.dir * l;
	}

	// ǂ
	float h = abs(step(0.001, abs(d)) - 1.0);

	// IuWFNg̖@擾
	vec3 n = getNormal(rot * ray.pos);

	// CgƖ@ŉAe
	float f = clamp(dot(rot * lightDir, n), 0.1, 1.0);

	// Ԍo߂ɂFω
	float t = u_time * 1.5;
	float r = sin(t);
	float g = cos(t);
	float b = atan(r, g);

	// F
	vec3 c = vec3(abs(r), abs(g), abs(b)) * f * h;

	// IuWF`悵ȂƂ͔wi`悷
	h = abs(step(10.001, h) - 1.0);
	c += vec3(0.1, 0.1, 0.5) * h;

	// ͂Â
	vec2 m = v_texCoord * 2.0 - 1.0;
	vec2 o = abs(m.yx) / vec2(6.0, 4.0);
	m += m * o * o;
	m = abs(m);
	m.x = pow(m.x, 15.0);
	m.y = pow(m.y, 15.0);
	r = mix(abs(c.r), 0.0, m.x + m.y);
	g = mix(abs(c.g), 0.0, m.x + m.y);
	b = mix(abs(c.b), 0.0, m.x + m.y);

	gl_FragColor = vec4(r, g, b, 1.0);
}
