// e֐͉L炨؂肵Ă܂

// SixteenSegmentDisplay.glsl
// 16 Segment Display Example v3
// rearranged source code by I.G.P.
// better comments added to source by Ded

// V-Drop - Del 19/11/2019 - (Tunnel mix - Enjoy)
// vertical version: https://www.shadertoy.com/view/tdGXWm
// https://www.shadertoy.com/view/wsKXRK

#ifdef OPENGL_ES
#extension GL_OES_standard_derivatives : enable
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#else
precision mediump float;
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform float u_time;
uniform vec3 u_resolution;	// ӁIdlIvec2Ȃ̂vec3őp
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;

vec2 uv;
const vec2 ch_size  = vec2(1.0, 2.0);              // character size (X,Y)
const vec2 ch_space = ch_size + vec2(1.0, 1.0);    // character distance Vector(X,Y)
const vec2 ch_start = vec2 (ch_space.x * -6.0, 4.0); // start position
      vec2 ch_pos   = vec2 (0.0, 0.0);             // character position(X,Y)
      vec3 ch_color = vec3 (0.0, 0.5, 2.5);        // character color (R,G,B)
const vec3 bg_color = vec3 (0.0, 0.0, 0.0);        // background color (R,G,B)

#define REPEAT_SIGN false // True/False; True=Multiple, False=Single

/* 16 segment display...Akin to LED Display.

Segment bit positions:
  __2__ __1__
 |\    |    /|
 | \   |   / |
 3  11 10 9  0
 |   \ | /   |
 |    \|/    |
  _12__ __8__
 |           |
 |    /|\    |
 4   / | \   7
 | 13 14  15 |
 | /   |   \ |
  __5__|__6__

15 12 11 8 7  4 3  0
 |  | |  | |  | |  |
 0000 0000 0000 0000

example: letter A

   12    8 7  4 3210
    |    | |  | ||||
 0001 0001 1001 1111

 binary to hex -> 0x119F
*/

#define n0 ddigit(0x22FF);
#define n1 ddigit(0x0281);
#define n2 ddigit(0x1177);
#define n3 ddigit(0x11E7);
#define n4 ddigit(0x5508);
#define n5 ddigit(0x11EE);
#define n6 ddigit(0x11FE);
#define n7 ddigit(0x2206);
#define n8 ddigit(0x11FF);
#define n9 ddigit(0x11EF);

#define A ddigit(0x119F);
#define B ddigit(0x927E);
#define C ddigit(0x007E);
#define D ddigit(0x44E7);
#define E ddigit(0x107E);
#define F ddigit(0x101E);
#define G ddigit(0x807E);
#define H ddigit(0x1199);
#define I ddigit(0x4466);
#define J ddigit(0x4436);
#define K ddigit(0x9218);
#define L ddigit(0x0078);
#define M ddigit(0x0A99);
#define N ddigit(0x8899);
#define O ddigit(0x00FF);
#define P ddigit(0x111F);
#define Q ddigit(0x80FF);
#define R ddigit(0x911F);
#define S ddigit(0x8866);
#define T ddigit(0x4406);
#define U ddigit(0x00F9);
#define V ddigit(0x2218);
#define W ddigit(0xA099);
#define X ddigit(0xAA00);
#define Y ddigit(0x4A00);
#define Z ddigit(0x2266);
#define _ ch_pos.x += ch_space.x;
#define s_dot     ddigit(0);
#define s_minus   ddigit(0x1100);
#define s_plus    ddigit(0x5500);
#define s_greater ddigit(0x2800);
#define s_less    ddigit(0x8200);
#define s_sqrt    ddigit(0x0C02);
#define nl0 ch_pos = ch_start; ch_pos.x += 1.0;
#define nl1 ch_pos = ch_start; ch_pos.x += 1.0; ch_pos.y -= 3.0;
#define nl2 ch_pos = ch_start; ch_pos.y -= 6.0;
#define nl3 ch_pos = ch_start; ch_pos.y -= 9.0;

float dseg(vec2 p0, vec2 p1)
{
	vec2 dir = normalize(p1 - p0);
	vec2 cp = (uv - ch_pos - p0) * mat2(dir.x, dir.y,-dir.y, dir.x);
	return distance(cp, clamp(cp, vec2(0), vec2(distance(p0, p1), 0)));
}

bool bit(int n, int b)
{
	return mod(floor(float(n) / exp2(floor(float(b)))), 2.0) != 0.0;
}

float d = 1e6;

void ddigit(int n)
{
	float v = 1e6;
	vec2 cp = uv - ch_pos;
	if (n == 0)     v = min(v, dseg(vec2(-0.405, -1.000), vec2(-0.500, -1.000)));
	if (bit(n,  0)) v = min(v, dseg(vec2( 0.500,  0.063), vec2( 0.500,  0.937)));
	if (bit(n,  1)) v = min(v, dseg(vec2( 0.438,  1.000), vec2( 0.063,  1.000)));
	if (bit(n,  2)) v = min(v, dseg(vec2(-0.063,  1.000), vec2(-0.438,  1.000)));
	if (bit(n,  3)) v = min(v, dseg(vec2(-0.500,  0.937), vec2(-0.500,  0.062)));
	if (bit(n,  4)) v = min(v, dseg(vec2(-0.500, -0.063), vec2(-0.500, -0.938)));
	if (bit(n,  5)) v = min(v, dseg(vec2(-0.438, -1.000), vec2(-0.063, -1.000)));
	if (bit(n,  6)) v = min(v, dseg(vec2( 0.063, -1.000), vec2( 0.438, -1.000)));
	if (bit(n,  7)) v = min(v, dseg(vec2( 0.500, -0.938), vec2( 0.500, -0.063)));
	if (bit(n,  8)) v = min(v, dseg(vec2( 0.063,  0.000), vec2( 0.438, -0.000)));
	if (bit(n,  9)) v = min(v, dseg(vec2( 0.063,  0.063), vec2( 0.438,  0.938)));
	if (bit(n, 10)) v = min(v, dseg(vec2( 0.000,  0.063), vec2( 0.000,  0.937)));
	if (bit(n, 11)) v = min(v, dseg(vec2(-0.063,  0.063), vec2(-0.438,  0.938)));
	if (bit(n, 12)) v = min(v, dseg(vec2(-0.438,  0.000), vec2(-0.063, -0.000)));
	if (bit(n, 13)) v = min(v, dseg(vec2(-0.063, -0.063), vec2(-0.438, -0.938)));
	if (bit(n, 14)) v = min(v, dseg(vec2( 0.000, -0.938), vec2( 0.000, -0.063)));
	if (bit(n, 15)) v = min(v, dseg(vec2( 0.063, -0.063), vec2( 0.438, -0.938)));
	ch_pos.x += ch_space.x;
	d = min(d, v);
}

vec3 hsv2rgb_smooth(in vec3 c)
{
	vec3 rgb = clamp(abs(mod(c.x * 6.0 + vec3(0.0, 4.0, 2.0), 6.0) - 3.0) - 1.0, 0.0, 1.0);
	rgb = rgb * rgb*(3.0 - 2.0 * rgb);
	return c.z * mix(vec3(1.0), rgb, c.y);
}

#define PI 3.14159

float vDrop(vec2 uv, float t)
{
	uv.x = uv.x * 128.0;			// H-Count
	float dx = fract(uv.x);
	uv.x = floor(uv.x);
	uv.y *= 0.05;				// stretch
	float o = sin(uv.x * 215.4);		// offset
	float s = cos(uv.x * 33.1) * 0.3 + 0.7;	// speed
	float trail = mix(95.0, 35.0, s);	// trail length
	float yv = fract(uv.y + t * s + o) * trail;
	yv = 1.0 / yv;
	yv = smoothstep(0.0, 1.0, yv * yv);
	yv = sin(yv * PI)*(s * 5.0);
	float d2 = sin(dx * PI);
	return yv * (d2 * d2);
}

void main()
{
	vec2 aspect = u_resolution.xy / u_resolution.y;
	uv = (gl_FragCoord.xy / u_resolution.y) - aspect / 2.0;
	// ̊gk
	uv *= 20.0 + step(0.5, sin(u_time * 13.0) * 5.0);

	// `
	nl0
	_ _ _ _ H S P n3
	nl1
	_ _ _ H G I M G n4
	nl2
	n2 n0 n2 n0 _ M Y A O S O F T

	// F
	//ch_color = vec3(1.0, 1.0, 1.0);//vec3(255,(7.-uv.y + uv.x * 0.5) * 77., 255)/255.;

	vec3 ch_color = hsv2rgb_smooth(vec3(u_time * 0.4 + uv.y * 0.1, 0.5, 1.0));
	vec3 c = mix(ch_color, bg_color, 1.0 - (0.5 / d));  // shading

	// wǐ
	vec2 p = (gl_FragCoord.xy - 0.5 * u_resolution.xy) / u_resolution.y;
	float d2 = length(p) + 0.1;
	p = vec2(atan(p.x, p.y) / PI, 2.5 / d2);
	float t =  u_time * 0.4;
	c += vec3(1.55, 0.65, 0.225) * vDrop(p, t);		// red
	c += vec3(0.55, 0.75, 1.225) * vDrop(p, t + 0.33);	// blue
	c += vec3(0.45, 1.15, 0.425) * vDrop(p, t + 0.66);	// green

	// XLC
	float s = sin(v_texCoord.y *  500.0 * 3.1415 + u_time * 3.0);
	s = mix(1.0, (s + 1.0), 1.0);

	// ͂Â
	vec2 m = v_texCoord * 2.0 - 1.0;
	vec2 o = abs(m.yx) / vec2(6.0, 4.0);
	m += m * o * o;
	m = abs(m);
	m.x = pow(m.x, 15.0);
	m.y = pow(m.y, 15.0);
	c.r = mix(c.r, 0.0, m.x + m.y) * s;
	c.g = mix(c.g, 0.0, m.x + m.y) * s;
	c.b = mix(c.b, 0.0, m.x + m.y) * s;

	gl_FragColor = vec4(c * (d2 * d2), 1.0);
}
